package com.biganto.visual.roompark.presentation.screen.auth

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.base.RoomParkApplication
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.conductor.BigantoBaseController
import com.google.android.material.snackbar.Snackbar
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */

class AuthScreenController  :
    BigantoBaseController<AuthScreenViewState
        , AuthScreen
        , AuthScreenPresenter>()
    , AuthScreen {

    override fun injectDependencies() {
        getComponent()
    }


    @Inject
    override lateinit var injectedPresenter: AuthScreenPresenter


//    @Inject
//    lateinit var snacky:ISnackBarProvider

    lateinit var rpActivity: RoomParkMainActivity

    fun getComponent() = DaggerAuthScreenComponent
        .factory()
        .create(RoomParkApplication.component,activity as RoomParkMainActivity)
        .inject(this)

//    @Inject
//    lateinit var ac: RoomParkMainActivity

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup): View {
        val v = super.onCreateView(inflater, container)

        return v
    }


    override fun render(viewState: AuthScreenViewState) {
        when(viewState){
            is AuthScreenViewState.Idle -> render(viewState)
            is AuthScreenViewState.ToScreen -> render(viewState)
        }
    }

    private fun render(viewState: AuthScreenViewState.Idle){

    }

    private fun render(viewState: AuthScreenViewState.ToScreen){
        snackbar.showSnackBar(viewState.message, Snackbar.LENGTH_LONG)
        toolBar.hideAll()
//        snacky.showSnackBar("lul")
    }


    override fun getLayoutId(): Int = R.layout.authentication_screen


}